//
// Created by Matthew on 2025/3/22.
//

#ifndef MPPREVIEW_HDRWRITER_H
#define MPPREVIEW_HDRWRITER_H


#include <vector>
#include <string>
#include <cstdint>
#include <fstream>

class HdrWriter {
public:
    static bool writeRGBE(const std::string& filename,
                          const std::vector<float>& data,
                          int width, int height);

    // New RGB file format support
    enum class Format {
        PNG,
        JPEG,
        BMP
    };

    static bool writeRGB(const std::string& filename,
                         const std::vector<float>& data,
                         int width, int height,
                         Format format = Format::PNG);

private:
    static void writeHeader(std::ofstream& file, int width, int height);
    static void rgbeFromFloat(float r, float g, float b, uint8_t rgbe[4]);
    static bool writeBMP(const std::string& filename,
                         const std::vector<float>& data,
                         int width, int height);
};

#endif //MPPREVIEW_HDRWRITER_H
