package com.xypower.mppreview.adapter;

import android.annotation.SuppressLint;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;
import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.xypower.mppreview.R;
import com.xypower.mppreview.interfaces.OnItemClickListener;

public class ItemAdapter extends RecyclerView.Adapter<ItemAdapter.MyViewHolder> {
    private Integer count;
    public OnItemClickListener listener;

    public class MyViewHolder extends RecyclerView.ViewHolder implements View.OnClickListener {
        private final TextView title;
        private OnItemClickListener listeners;
        public MyViewHolder(View view, OnItemClickListener listener) {
            super(view);
            this.listeners = listener;
            title = view.findViewById(R.id.channel);
            title.setOnClickListener(this);
        }

        public TextView getTitle() {
            return title;
        }

        @Override
        public void onClick(View v) {
            if (listeners != null) {
                listeners.onItemClick(v, getAdapterPosition());
            }
        }
    }

    public ItemAdapter(Integer itemcount) {
        this.count = itemcount;
    }


    public void setOnClickListener(OnItemClickListener listener) {
        this.listener = listener;

    }
    @NonNull
    @Override
    public MyViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.item_view, parent, false);
        return new MyViewHolder(view,listener);
    }

    @Override
    public void onBindViewHolder(@NonNull MyViewHolder holder, @SuppressLint("RecyclerView") int position) {
//        Integer item = itemList.get(position);
        holder.getTitle().setText("通道"+(position+1));
    }

    @Override
    public int getItemCount() {
        return count;
    }
}