package com.xypower.mppreview.utils;


import android.app.Activity;
import android.content.Context;
import android.content.res.AssetManager;
import android.util.Log;

import java.io.Closeable;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.text.SimpleDateFormat;
import java.util.Arrays;
import java.util.Date;
import java.util.Locale;

public class HdrUtil {

    public static void copyAssetsDir(Context context, String directory, String destPath) {
        try {
            AssetManager assetManager = context.getAssets();
            String[] fileList = assetManager.list(directory);
            if (fileList != null && fileList.length > 0) {
                File file = new File(destPath);
                if (!file.exists()) {
                    file.mkdirs();
                }

                if (!directory.endsWith(File.separator)) {
                    directory += File.separator;
                }
                if (!destPath.endsWith(File.separator)) {
                    destPath += File.separator;
                }

                for (String fileName : fileList) {
                    copyAssetsDir(context, directory + fileName, destPath + fileName);
                }
            } else {
                // Try to file
                copyAssetsFile(context, directory, destPath);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        //  else {//如果是文件
        //                InputStream inputStream=context.getAssets().open(filePath);
        //                File file=new File(context.getFilesDir().getAbsolutePath()+ File.separator+filePath);
        //                Log.i("copyAssets2Phone","file:"+file);
        //                if(!file.exists() || file.length()==0) {
        //                    FileOutputStream fos=new FileOutputStream(file);
        //                    int len=-1;
        //                    byte[] buffer=new byte[1024];
        //                    while ((len=inputStream.read(buffer))!=-1){
        //                        fos.write(buffer,0,len);
        //                    }
        //                    fos.flush();
        //                    inputStream.close();
        //                    fos.close();
        //                    showToast(context,"模型文件复制完毕");
        //                } else {
        //                    showToast(context,"模型文件已存在，无需复制");
        //                }
        //            }
    }


    public static void copyAssetsFile(Context context, String fileName, String destPath) {
        InputStream inputStream = null;
        FileOutputStream fos = null;
        try {
            inputStream = context.getAssets().open(fileName);
            //getFilesDir() 获得当前APP的安装路径 /data/data/包名/files 目录
            File file = new File(destPath);
            if (file.exists()) {
                file.delete();
            }

            fos = new FileOutputStream(file);
            int len = -1;
            byte[] buffer = new byte[1024];
            while ((len = inputStream.read(buffer)) != -1) {
                fos.write(buffer, 0, len);
            }
            fos.flush();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            closeFriendly(inputStream);
            closeFriendly(fos);
        }
    }

    public static void closeFriendly(Closeable closeable) {
        if (closeable != null) {
            try {
                closeable.close();
            } catch (Exception ex) {
            }
            closeable = null;
        }
    }

    public static String generateTimestamp() {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd_HHmmss_SSS", Locale.US);
        return sdf.format(new Date());
    }

//    public static void createHDR(Mat[] images, float[] exposureTimes, Mat hdrImage,String filepath) {
//        Mat[] images32f = new Mat[images.length];
//        for (int i = 0; i < images.length; i++) {
//            images32f[i] = new Mat();
//            images[i].convertTo(images32f[i], CvType.CV_32F);
//        }
//
//        Mat response = new Mat();
//        Mat times = new Mat(exposureTimes.length, 1, CvType.CV_32F);
//        for (int i = 0; i < exposureTimes.length; i++) {
//            times.put(i, 0, exposureTimes[i]);
//        }
//
//        // Calibrate the camera response
//        CalibrateDebevec calibrate = createCalibrateDebevec();
//        calibrate.process(Arrays.asList(images32f), response, times);
//
//        // Merge the images into an HDR image
//        MergeDebevec merge = createMergeDebevec();
//        merge.process(Arrays.asList(images32f), hdrImage, times, response);
//        saveHDRImage(hdrImage,filepath);
//    }
//
//    public static void saveHDRImage(Mat hdrImage, String filePath) {
//        Imgcodecs.imwrite(filePath, hdrImage);
//    }




}
